
package com.linkedin.repo.acl.api;

import java.util.List;
import javax.annotation.Generated;
import com.linkedin.data.DataMap;
import com.linkedin.data.schema.PathSpec;
import com.linkedin.data.schema.RecordDataSchema;
import com.linkedin.data.template.DataTemplateUtil;
import com.linkedin.data.template.GetMode;
import com.linkedin.data.template.RecordTemplate;
import com.linkedin.data.template.SetMode;


/**
 * An ownership record
 * 
 */
@Generated(value = "com.linkedin.pegasus.generator.PegasusDataTemplateGenerator", comments = "LinkedIn Data Template. Generated from /Users/jbetz/projects/pegasus/restli-int-test-api/src/main/pegasus/com/linkedin/repo/acl/api/OwnershipRecord.pdsc.", date = "Tue Jan 22 17:40:46 PST 2013")
public class OwnershipRecord
    extends RecordTemplate
{

    private final static OwnershipRecord.Fields _fields = new OwnershipRecord.Fields();
    private final static RecordDataSchema SCHEMA = ((RecordDataSchema) DataTemplateUtil.parseSchema("{\"type\":\"record\",\"name\":\"OwnershipRecord\",\"namespace\":\"com.linkedin.repo.acl.api\",\"doc\":\"An ownership record\",\"fields\":[{\"name\":\"owner_name\",\"type\":\"string\"},{\"name\":\"acls\",\"type\":{\"type\":\"array\",\"items\":{\"type\":\"record\",\"name\":\"ACL\",\"doc\":\"An ACL\",\"fields\":[{\"name\":\"acl_name\",\"type\":\"string\"},{\"name\":\"paths\",\"type\":{\"type\":\"array\",\"items\":\"string\"}}]}}}]}"));
    private final static RecordDataSchema.Field FIELD_Owner_name = SCHEMA.getField("owner_name");
    private final static RecordDataSchema.Field FIELD_Acls = SCHEMA.getField("acls");

    public OwnershipRecord() {
        super(new DataMap(), SCHEMA);
    }

    public OwnershipRecord(DataMap data) {
        super(data, SCHEMA);
    }

    public static OwnershipRecord.Fields fields() {
        return _fields;
    }

    /**
     * Existence checker for owner_name
     * 
     * @see Fields#owner_name
     */
    public boolean hasOwner_name() {
        return contains(FIELD_Owner_name);
    }

    /**
     * Remover for owner_name
     * 
     * @see Fields#owner_name
     */
    public void removeOwner_name() {
        remove(FIELD_Owner_name);
    }

    /**
     * Getter for owner_name
     * 
     * @see Fields#owner_name
     */
    public String getOwner_name(GetMode mode) {
        return obtainDirect(FIELD_Owner_name, String.class, mode);
    }

    /**
     * Getter for owner_name
     * 
     * @see Fields#owner_name
     */
    public String getOwner_name() {
        return getOwner_name(GetMode.STRICT);
    }

    /**
     * Setter for owner_name
     * 
     * @see Fields#owner_name
     */
    public OwnershipRecord setOwner_name(String value, SetMode mode) {
        putDirect(FIELD_Owner_name, String.class, String.class, value, mode);
        return this;
    }

    /**
     * Setter for owner_name
     * 
     * @see Fields#owner_name
     */
    public OwnershipRecord setOwner_name(String value) {
        putDirect(FIELD_Owner_name, String.class, String.class, value, SetMode.DISALLOW_NULL);
        return this;
    }

    /**
     * Existence checker for acls
     * 
     * @see Fields#acls
     */
    public boolean hasAcls() {
        return contains(FIELD_Acls);
    }

    /**
     * Remover for acls
     * 
     * @see Fields#acls
     */
    public void removeAcls() {
        remove(FIELD_Acls);
    }

    /**
     * Getter for acls
     * 
     * @see Fields#acls
     */
    public ACLArray getAcls(GetMode mode) {
        return obtainWrapped(FIELD_Acls, ACLArray.class, mode);
    }

    /**
     * Getter for acls
     * 
     * @see Fields#acls
     */
    public ACLArray getAcls() {
        return getAcls(GetMode.STRICT);
    }

    /**
     * Setter for acls
     * 
     * @see Fields#acls
     */
    public OwnershipRecord setAcls(ACLArray value, SetMode mode) {
        putWrapped(FIELD_Acls, ACLArray.class, value, mode);
        return this;
    }

    /**
     * Setter for acls
     * 
     * @see Fields#acls
     */
    public OwnershipRecord setAcls(ACLArray value) {
        putWrapped(FIELD_Acls, ACLArray.class, value, SetMode.DISALLOW_NULL);
        return this;
    }

    public static class Fields
        extends PathSpec
    {


        public Fields(List<String> path, String name) {
            super(path, name);
        }

        public Fields() {
            super();
        }

        public PathSpec owner_name() {
            return new PathSpec(getPathComponents(), "owner_name");
        }

        public com.linkedin.repo.acl.api.ACLArray.Fields acls() {
            return new com.linkedin.repo.acl.api.ACLArray.Fields(getPathComponents(), "acls");
        }

    }

}
