
package com.linkedin.restli.examples.groups.client;

import java.util.EnumSet;
import java.util.HashMap;
import javax.annotation.Generated;
import com.linkedin.data.template.DynamicRecordMetadata;
import com.linkedin.restli.common.CompoundKey;
import com.linkedin.restli.common.ResourceMethod;
import com.linkedin.restli.common.ResourceSpec;
import com.linkedin.restli.common.ResourceSpecImpl;
import com.linkedin.restli.examples.groups.api.GroupMembership;


/**
 * Association between members and groups
 * 
 * generated from: com.linkedin.restli.examples.groups.server.rest.impl.GroupMembershipsResource2
 * 
 */
@Generated(value = "com.linkedin.restli.tools.clientgen.RestRequestBuilderGenerator", comments = "LinkedIn Request Builder. Generated from /Users/jbetz/projects/pegasus/restli-int-test-api/src/main/idl/com.linkedin.restli.examples.groups.client.groupMemberships.restspec.json.", date = "Tue Jan 22 17:40:49 PST 2013")
public class GroupMembershipsBuilders {

    private final String _baseUriTemplate;
    private final static ResourceSpec _resourceSpec;

    static {
        HashMap<String, Class<?>> keyParts = new HashMap<String, Class<?>>();
        keyParts.put("groupID", Integer.class);
        keyParts.put("memberID", Integer.class);
        HashMap<String, DynamicRecordMetadata> requestMetadataMap = new HashMap<String, DynamicRecordMetadata>();
        HashMap<String, DynamicRecordMetadata> responseMetadataMap = new HashMap<String, DynamicRecordMetadata>();
        _resourceSpec = new ResourceSpecImpl(EnumSet.of(ResourceMethod.GET, ResourceMethod.BATCH_GET, ResourceMethod.PARTIAL_UPDATE, ResourceMethod.UPDATE, ResourceMethod.BATCH_UPDATE, ResourceMethod.DELETE, ResourceMethod.BATCH_DELETE, ResourceMethod.GET_ALL), requestMetadataMap, responseMetadataMap, CompoundKey.class, null, null, GroupMembership.class, keyParts);
    }

    public GroupMembershipsBuilders() {
        _baseUriTemplate = "groupMemberships";
    }

    public GroupMembershipsBuilders(String primaryResourceName) {
        _baseUriTemplate = primaryResourceName;
    }

    public GroupMembershipsUpdateBuilder update() {
        return new GroupMembershipsUpdateBuilder(_baseUriTemplate, _resourceSpec);
    }

    public GroupMembershipsGetAllBuilder getAll() {
        return new GroupMembershipsGetAllBuilder(_baseUriTemplate, _resourceSpec);
    }

    public GroupMembershipsBatchDeleteBuilder batchDelete() {
        return new GroupMembershipsBatchDeleteBuilder(_baseUriTemplate, _resourceSpec);
    }

    public GroupMembershipsBatchUpdateBuilder batchUpdate() {
        return new GroupMembershipsBatchUpdateBuilder(_baseUriTemplate, _resourceSpec);
    }

    public GroupMembershipsPartialUpdateBuilder partialUpdate() {
        return new GroupMembershipsPartialUpdateBuilder(_baseUriTemplate, _resourceSpec);
    }

    public GroupMembershipsBatchGetBuilder batchGet() {
        return new GroupMembershipsBatchGetBuilder(_baseUriTemplate, _resourceSpec);
    }

    public GroupMembershipsGetBuilder get() {
        return new GroupMembershipsGetBuilder(_baseUriTemplate, _resourceSpec);
    }

    public GroupMembershipsDeleteBuilder delete() {
        return new GroupMembershipsDeleteBuilder(_baseUriTemplate, _resourceSpec);
    }

    public GroupMembershipsFindByGroupBuilder findByGroup() {
        return new GroupMembershipsFindByGroupBuilder(_baseUriTemplate, _resourceSpec);
    }

    public GroupMembershipsFindByMemberBuilder findByMember() {
        return new GroupMembershipsFindByMemberBuilder(_baseUriTemplate, _resourceSpec);
    }

    public static class Key
        extends CompoundKey
    {


        public Key() {
        }

        public GroupMembershipsBuilders.Key setGroupId(Integer groupID) {
            append("groupID", groupID);
            return this;
        }

        public Integer getGroupId() {
            return ((Integer) getPart("groupID"));
        }

        public GroupMembershipsBuilders.Key setMemberId(Integer memberID) {
            append("memberID", memberID);
            return this;
        }

        public Integer getMemberId() {
            return ((Integer) getPart("memberID"));
        }

    }

}
